VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMakeMap 
   Caption         =   "MakeMap []"
   ClientHeight    =   2775
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4935
   LinkTopic       =   "Form2"
   ScaleHeight     =   2775
   ScaleWidth      =   4935
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picHidden 
      AutoSize        =   -1  'True
      Height          =   2775
      Left            =   600
      ScaleHeight     =   181
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   181
      TabIndex        =   2
      Top             =   360
      Visible         =   0   'False
      Width           =   2775
   End
   Begin VB.ListBox lstStates 
      Height          =   2775
      IntegralHeight  =   0   'False
      Left            =   2880
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   0
      Width           =   2055
   End
   Begin MSComDlg.CommonDialog dlgOpenFile 
      Left            =   1560
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picVisible 
      AutoSize        =   -1  'True
      Height          =   2775
      Left            =   0
      ScaleHeight     =   181
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   181
      TabIndex        =   0
      Top             =   0
      Width           =   2775
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Enabled         =   0   'False
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
         Index           =   8
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuStates 
      Caption         =   "&States"
      Begin VB.Menu mnuStatesAll 
         Caption         =   "&All States"
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuStatesDeleteSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuStateDelete 
         Caption         =   "&Delete State"
         Enabled         =   0   'False
         Shortcut        =   ^D
      End
      Begin VB.Menu mnuStateNew 
         Caption         =   "&New State"
         Enabled         =   0   'False
         Shortcut        =   ^N
      End
   End
End
Attribute VB_Name = "frmMakeMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_States As Collection

Private m_FileTitle As String

Private m_SelectedState As State

Private m_DataModified As Boolean
' Arrange the controls.
Private Sub ArrangeControls()
    lstStates.Move picVisible.Width + 30, _
        0, lstStates.Width, picVisible.Height

    ' Make the form big enough.
    Width = lstStates.Left + lstStates.Width + _
        Width - ScaleWidth
    Height = lstStates.Height + Height - ScaleHeight

    DoEvents
End Sub
Private Function DataSafe() As Boolean
    If Not m_DataModified Then
        DataSafe = True
    Else
        Select Case MsgBox("The data has been modified. Do you want to save the changes?", _
                vbYesNoCancel Or vbQuestion, "Data Modified")
            Case vbYes
                SaveData
                DataSafe = Not m_DataModified
            Case vbNo
                DataSafe = True
            Case vbCancel
                DataSafe = False
        End Select
    End If
End Function

Private Sub LoadData()
Dim fnum As Integer
Dim num_states As Integer
Dim i As Integer
Dim s As State

    Set m_States = New Collection

    fnum = FreeFile
    On Error Resume Next
    Open m_FileTitle & ".dat" For Input As fnum
    If Err.Number <> 0 Then Exit Sub

    lstStates.Clear

    Input #fnum, num_states
    For i = 1 To num_states
        Set s = New State
        s.ReadFromFile fnum
        m_States.Add s, s.StateName
        lstStates.AddItem s.StateName
    Next i

    Close #fnum

    m_DataModified = False
End Sub
Private Sub SaveData()
Dim fnum As Integer
Dim s As State

    fnum = FreeFile
    On Error Resume Next
    Open m_FileTitle & ".dat" For Output As fnum
    If Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " opening file " & m_FileTitle & ".dat" & _
            vbCrLf & Err.Description
        Exit Sub
    End If

    Write #fnum, m_States.Count
    For Each s In m_States
        s.WriteToFile fnum
    Next s

    Close #fnum

    m_DataModified = False
    Caption = "MakeMap [" & m_FileTitle & "]"
End Sub
Private Sub SetDirty()
    If m_DataModified Then Exit Sub

    m_DataModified = True
    Caption = "MakeMap*[" & m_FileTitle & "]"
End Sub
' Start in the current directory.
Private Sub Form_Load()
    picVisible.FillStyle = vbFSSolid

    Set m_States = New Collection

    picVisible.AutoSize = True
    picVisible.ScaleMode = vbPixels
    picVisible.AutoRedraw = True

    dlgOpenFile.CancelError = True
    dlgOpenFile.InitDir = App.Path
    dlgOpenFile.Filter = _
        "Bitmaps (*.bmp)|*.bmp|" & _
        "GIFs (*.gif)|*.gif|" & _
        "JPEGs (*.jpg)|*.jpg;*.jpeg|" & _
        "Icons (*.ico)|*.ico|" & _
        "Cursors (*.cur)|*.cur|" & _
        "Run-Length Encoded (*.rle)|*.rle|" & _
        "Metafiles (*.wmf)|*.wmf|" & _
        "Enhanced Metafiles (*.emf)|*.emf|" & _
        "Graphic Files|*.bmp;*.gif;*.jpg;*.jpeg;*.ico;*.cur;*.rle;*.wmf;*.emf|" & _
        "All Files (*.*)|*.*"
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Cancel = Not DataSafe()
End Sub


Private Sub lstStates_Click()
    picVisible.Picture = picHidden.Picture
    Set m_SelectedState = Nothing

    On Error Resume Next
    Set m_SelectedState = m_States(lstStates.Text)
    If Err.Number <> 0 Then
        lstStates.ListIndex = -1
        mnuStateDelete.Enabled = False
        Exit Sub
    End If
    On Error GoTo 0

    m_SelectedState.HighlightState picVisible, COLOR_SELECTED
    mnuStateDelete.Enabled = True

    picVisible.Picture = picVisible.Image
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' Load the indicated file.
Private Sub mnuFileOpen_Click()
Dim file_name As String

    If Not DataSafe() Then Exit Sub

    ' Let the user select a file.
    On Error Resume Next
    dlgOpenFile.Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly
    dlgOpenFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        Beep
        MsgBox "Error selecting file.", , vbExclamation
        Exit Sub
    End If
    On Error GoTo 0

    Screen.MousePointer = vbHourglass
    DoEvents

    file_name = Trim$(dlgOpenFile.FileName)
    dlgOpenFile.InitDir = Left$(file_name, Len(file_name) _
        - Len(dlgOpenFile.FileTitle) - 1)
    m_FileTitle = Left$(dlgOpenFile.FileTitle, _
        InStrRev(dlgOpenFile.FileTitle, ".") - 1)
    Caption = "MakeMap [" & m_FileTitle & "]"

    ' Open the original file.
    On Error GoTo LoadError
    picVisible.Picture = LoadPicture(file_name)
    picHidden.Picture = picVisible.Picture
    On Error GoTo 0

    ' Try to load the data.
    LoadData

    ArrangeControls

    mnuFileSave.Enabled = True
    mnuStateNew.Enabled = True
    mnuStateDelete.Enabled = False

    Screen.MousePointer = vbDefault
    Exit Sub

LoadError:
    Screen.MousePointer = vbDefault
    MsgBox "Error " & Format$(Err.Number) & _
        " opening file '" & file_name & "'" & vbCrLf & _
        Err.Description
End Sub
' Save the data.
Private Sub mnuFileSave_Click()
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Save the state data.
    SaveData

    Screen.MousePointer = vbDefault
End Sub

Private Sub mnuStateDelete_Click()
    If m_SelectedState Is Nothing Then Exit Sub

    m_States.Remove m_SelectedState.StateName
    Set m_SelectedState = Nothing

    lstStates.RemoveItem lstStates.ListIndex

    picVisible.Picture = picHidden.Picture

    SetDirty
End Sub

Private Sub mnuStateNew_Click()
Dim state_name As String
Dim s As State

    state_name = InputBox("Name", "State Name", "")
    If state_name = "" Then Exit Sub

    Set s = New State
    s.StateName = state_name

    On Error Resume Next
    m_States.Add s, state_name
    If Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            vbCrLf & Err.Description
        Exit Sub
    End If
    On Error GoTo 0

    lstStates.AddItem state_name
    lstStates.ListIndex = lstStates.NewIndex

    SetDirty
End Sub


Private Sub mnuStatesAll_Click()
Dim s As State

    Set m_SelectedState = Nothing
    lstStates.ListIndex = -1

    For Each s In m_States
        s.HighlightState picVisible, COLOR_SELECTED
    Next s
    picVisible.Picture = picVisible.Image
End Sub


' Toggle this region for the state object.
Private Sub picVisible_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim clr As Long

    If m_SelectedState Is Nothing Then Exit Sub
    SetDirty

    clr = picVisible.Point(X, Y)
    If clr = COLOR_SELECTED Then
        m_SelectedState.DeselectPoint picVisible, X, Y
    ElseIf clr = COLOR_UNSELECTED Then
        m_SelectedState.SelectPoint picVisible, X, Y
    End If

    picVisible.Picture = picVisible.Image
End Sub
